//bmp.h: header file for the bmp file reader
//Daniel CopyRight Reserved December, 5, 2001

//\G
//1) ŪJ BMP ɨtΰOаϡC
//2) NLMɸƽƻsY SurfaceW

#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>

#include "Glvar.h"

#ifndef __bmp_h__
#define __bmp_h__

class CBmpFileReader  //BmpŪO
{ 
  protected:  //iQlOs
    BITMAPFILEHEADER BMPFileHead; //Ѽ memberAΨӦs BMP ɪ Header  
    BITMAPINFOHEADER BMPFileInfo; //sɸT (ơBbitơBe...)
    RGBQUAD PaletteData[GameCOLORS]; //sL
    BYTE *ImageData; //sϧθ

  public:  //iQlOs
    CBmpFileReader(); //constructor
    ~CBmpFileReader(); //destructor
    BOOL load(char *filename); //Ūɵ{
    BOOL draw2Surface(LPDIRECTDRAWSURFACE lpsurface); //Nϧθƽƻs Surface
    BOOL setSurfacePalette(LPDIRECTDRAWPALETTE lppalette); //NLƽƻs Surface  lpPalette
	virtual BOOL AlphaDraw2Surface(LPDIRECTDRAWSURFACE lpsurface, BYTE Alpha);//zĪG			
	int ImageWidth();  //Ǧ^ɼe
	int ImageHeight(); //Ǧ^ɰ
	COLORREF GetPaletteColor(int i);

};


class CBmpSpriteFileReader: public CBmpFileReader //o̪ public rܱNNO protectedBpublic ܦۤv public 
{
  public:
	//N Image  Rectangle e Surface W
    BOOL draw2Surface(LPDIRECTDRAWSURFACE lpsurface,int w,int h,int x,int y); //ѼƻPNPAOverrideC
	virtual BOOL AlphaDraw2Surface(LPDIRECTDRAWSURFACE lpsurface, //zĪG
			int w, int h, int x, int y, BYTE Alpha);
};

#endif
