//DanielMath.cpp: member functions for the DanielMath.h
//Daniel CopyRight Reserved December, 5, 2001




//System includes
#include <math.h>

//custom includes
#include "DanielMath.h" //header file




//------------------------------------------------------------------------------
//P_uqO_ۥAöǦ^I
bool Line_CrossInPt(LineRec L1, LineRec L2, float *m1, float *m2, PointXY *pt)
{
	int L1sx, L1sy, L1ex, L1ey,
		L2sx, L2sy, L2ex, L2ey;

	L1sx=L1.SX; L1sy=L1.SY; L1ex=L1.EX; L1ey=L1.EY;
	L2sx=L2.SX; L2sy=L2.SY; L2ex=L2.EX; L2ey=L2.EY;

	return (LineCrossInPt(L1sx, L1sy, L1ex, L1ey, L2sx, L2sy, L2ex, L2ey,
						  m1, m2, &(pt->x), &(pt->y)));
}


//--------------------P_u_O_ۥ檺z----------------------------------
//	OgUu{ f1(x,y)=0, f2(x,y)=0
//	pG f1(x3,y3)*f1(x4,y4)<=0 B f2(x1, y1)*f2(x2,y2)<=0
//  oӦlߡAhuqۥ
//-------------------------------------------------------------------------------
bool LineCrossInPt(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4,
			   float *m1, float *m2, int *xc, int *yc)
{     
  //float m1,m2; //m1: line1 ײvAm2: Line2 ײvC
  short sign1,sign2,sign3,sign4;      //sign#: if point# is beside line or in line
  bool crossed;
  
  crossed=false; *m1=*m2=999999.0;  

  if (x1!=x2 ) //pGLine1 Ouq
  {
    *m1=float(y2-y1)/(x2-x1); //m1: line1 (x1,y1)-(x2,y2) ײv (y2-y1)/(x2-x1)=m1=(y-y1)/(x-x1);
    if (((*m1)*x3-y3)>((*m1)*x1-y1) ) sign3=1;		//f1(x3,y3)>0 sign3=1;
    else if (((*m1)*x3-y3)<((*m1)*x1-y1) ) sign3=-1;	//f1(x3,y3)<0 
    else sign3=0;								//f1(x3,y3)=0

    if (((*m1)*x4-y4)>((*m1)*x1-y1) ) sign4=1;		//f1(x4,y4)>0
    else if (((*m1)*x4-y4)<((*m1)*x1-y1) ) sign4=-1;	//f1(x4,y4)<0
    else sign4=0;								//f1(x4,y4)=0

    if ((sign3==1))		//f1(x3,y3)>0
    {
      if ((sign4==-1))	//f1(x4,y4)*f1(x3,y3)<0
      {
        if (x3!=x4 )	//line2 Duq
        {
          (*m2)=float(y4-y3)/(x4-x3);
          if (((*m2)*x1-y1)>((*m2)*x3-y3) ) sign1=1;		//f2(x1,y1)>0
          else if (((*m2)*x1-y1)<((*m2)*x3-y3) ) sign1=-1;//f2(x1,y1)<0
          else sign1=0;								//f2(x1,y1)=0;

          if (((*m2)*x2-y2)>((*m2)*x3-y3) ) sign2=1;		//f2(x2,y2)>0
          else if (((*m2)*x2-y2)<((*m2)*x3-y3) ) sign2=-1;//f2(x2,y2)<0
          else sign2=0;								//f2(x2,y2)=0

          if (sign1*sign2<=0 ) //line1 Aline2 
		  {
			  if (sign1==0)
			  {
				(*xc)=x1; (*yc)=y1; 
			  }
			  else if (sign2==0)
			  {
				(*xc)=x2; (*yc)=y2;
			  }
			  else // line1 Ou line2]Ou
			  {
				(*xc)=int(((*m1)*x1-(*m2)*x3-y1+y3)/((*m1)-(*m2)));
				(*yc)=int((*m1)*((*xc)-x1))+y1;
			  }
			  return true;	//f2(x1,y1)*f2(x2,y2)<=0;	
		  }
        }
        else //x3=x4 line2 Ouq
        {
          if ((x1>x3) ) sign1=1;		//x1b line2 k
          else if ((x1<x3) ) sign1=-1;	//x1b line2 
          else sign1=0;					//x1b line2 uW(@wbuqW)
			
          if ((x2>x3) ) sign2=1;
          else if ((x2<x3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) //line1 Aline2 
		  {
			  if (sign1==0)
			  {
				(*xc)=x1; (*yc)=y1; 
			  }
			  else if (sign2==0)
			  {
				(*xc)=x2; (*yc)=y2;
			  }
			  else  //line1 Aline2 
			  {
				(*xc)=x3;
				(*yc)=int((*m1)*((*xc)-x1))+y1; //QΤҪkX  m1=(y2-y1)/(x2-x1)=(yc-y1)/(xc-x1);
			  }
			  return true;
		  }
        }
      }
      else if (sign4==0 )   //sign3=1, sign4=0;  f1(x4,y4)*f1(x3,y3)=0
      if (abs(x4-x1)+abs(x4-x2)==abs(x1-x2) ) 
	  {
		(*xc)=x4; (*yc)=y4;			
		return true;
	  }
    }
    else if (sign3==-1 )  //sign3=-1;
    {
      if ((sign4==1) )
      {
        if (x3!=x4 )
        {
          (*m2)=float(y4-y3)/(x4-x3);
          if (((*m2)*x1-y1)>((*m2)*x3-y3) ) sign1=1;
          else if (((*m2)*x1-y1)<((*m2)*x3-y3) ) sign1=-1;
          else sign1=0;

          if (((*m2)*x2-y2)>((*m2)*x3-y3) ) sign2=1;
          else if (((*m2)*x2-y2)<((*m2)*x3-y3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) //line1 A line2 
		  {
			  if (sign1==0)
			  {
				(*xc)=x1; (*yc)=y1; 
			  }
			  else if (sign2==0)
			  {
				(*xc)=x2; (*yc)=y2;
			  }
			  else  //line1 Aline2 
			  {
				(*xc)=int(((*m1)*x1-(*m2)*x3-y1+y3)/((*m1)-(*m2)));
				(*yc)=int((*m1)*(*xc-x1))+y1;
			  }
			  return true;
		  }
        }
        else //x3=x4 line2 
        {
          if ((x1>x3) ) sign1=1;
          else if ((x1<x3) ) sign1=-1;
          else sign1=0;

          if ((x2>x3) ) sign2=1;
          else if ((x2<x3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) //line1 , line2
		  {
			  if (sign1==0)
			  {
				(*xc)=x1; (*yc)=y1; 
			  }
			  else if (sign2==0)
			  {
				(*xc)=x2; (*yc)=y2;
			  }
			  else  //line1 Aline2 
			  {
				(*xc)=x3;
				(*yc)=int((*m1)*((*xc)-x1))+y1; //QΤҪkX  m1=(y2-y1)/(x2-x1)=(yc-y1)/(xc-x1);
			  }
			  return true;
		  }
        }
      }
      else if (sign4==0 )   //sign3=1, sign4=0; line1
        if (abs(x4-x1)+abs(x4-x2)==abs(x1-x2) )
		{
			(*xc)=x4; (*yc)=y4;
		    return true;
		}
    }
    else //sing3=0  line1 
    {
      if (abs(x3-x1)+abs(x3-x2)==abs(x1-x2) )
	  {
		  (*xc)=x3; (*yc)=y3;
		  return true;
	  }
    }
  }
  else //x1=x2  line1 
  {
    if ((x3>x1) ) sign3=1;
    else if ((x3<x1) ) sign3=-1;
    else sign3=0;

    if ((x4>x1) ) sign4=1;
    else if ((x4<x1) ) sign4=-1;
    else sign4=0;

    if ((sign3==1) )
    {
      if ((sign4==-1) )
      {
        if (x3!=x4 )
        {
          (*m2)=float(y4-y3)/(x4-x3);
          if (((*m2)*x1-y1)>((*m2)*x3-y3) ) sign1=1;
          else if (((*m2)*x1-y1)<((*m2)*x3-y3) ) sign1=-1;
          else sign1=0;

          if (((*m2)*x2-y2)>((*m2)*x3-y3) ) sign2=1;
          else if (((*m2)*x2-y2)<((*m2)*x3-y3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) //line1 Aline2 
		  {
			  if (sign1==0)
			  {
				(*xc)=x1; (*yc)=y1; 
			  }
			  else if (sign2==0)
			  {
				(*xc)=x2; (*yc)=y2;
			  }
			  else  //line1 Aline2 
			  {
				(*xc)=x1;
				(*yc)=int((*m2)*(*xc-x3))+y3; //QΤҪkX  m2=(y4-y3)/(x4-x3)=(yc-y3)/(xc-x3);
			  }
			  return true;
		  }
        }
        else //x3=x4
        {
          if ((x1>x3) ) sign1=1;
          else if ((x1<x3) ) sign1=-1;
          else sign1=0;

          if ((x2>x3) ) sign2=1;
          else if ((x2<x3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) //line1 Aline2 
		  {
			  if (sign1==0)
			  {
				(*xc)=x1; (*yc)=y1;
			  }
			  else if (sign2==0)
			  {
				(*xc)=x2; (*yc)=y2;
			  }
			  else  //line1 Aline2 
			  {
				(*xc)=x3;
				(*yc)=y3;
			  }
			  return true;
		  }
        }
      }
      else if (sign4==0 )   //sign3=1, sign4=0;  line1 
        if (abs(y4-y1)+abs(y4-y2)==abs(y1-y2) )
		{
			(*xc)=x4;
			(*yc)=y4;
			return true;
		}
    }
    else if (sign3==-1 )  //sign3=-1; line1 
    {
      if ((sign4==1) )
      {
        if (x3!=x4 )
        {
          (*m2)=float(y4-y3)/(x4-x3);
          if (((*m2)*x1-y1)>((*m2)*x3-y3) ) sign1=1;
          else if (((*m2)*x1-y1)<((*m2)*x3-y3) ) sign1=-1;
          else sign1=0;

          if (((*m2)*x2-y2)>((*m2)*x3-y3) ) sign2=1;
          else if (((*m2)*x2-y2)<((*m2)*x3-y3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) //line1 , line2 
		  {
			  if (sign1==0)
			  {
				(*xc)=x1; (*yc)=y1; 
			  }
			  else if (sign2==0)
			  {
				(*xc)=x2; (*yc)=y2;
			  }
			  else  //line1 Aline2 
			  {
				(*xc)=x1;
				(*yc)=int((*m2)*(*xc-x3))+y3; //QΤҪkX  m2=(y4-y3)/(x4-x3)=(yc-y3)/(xc-x3);
			  }	
			  return true;
		  }
        }
        else //x3=x4
        {
          if ((x1>x3) ) sign1=1;
          else if ((x1<x3) ) sign1=-1;
          else sign1=0;

          if ((x2>x3) ) sign2=1;
          else if ((x2<x3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 )  //line1 , line2  
		  {
			  if (sign1==0)
			  {
				(*xc)=x1; (*yc)=y1; 
			  }
			  else if (sign2==0)
			  {
				(*xc)=x2; (*yc)=y2;
			  }
			  else  //line1 Aline2 
			  {
				(*xc)=x3;
				(*yc)=y3;
			  }
			  return true;
		  }
        }
      }
      else if (sign4==0 )   //sign3=1, sign4=0; line1 
        if (abs(y4-y1)+abs(y4-y2)==abs(y1-y2) )
		{
			(*xc)=x4; (*yc)=y4;
			return true;
		}
    }
    else //sing3=0
    {
      if (abs(y3-y1)+abs(y3-y2)==abs(y1-y2) )
	  {
		(*xc)=x3;
		(*yc)=y3;
		return true;
	  }
    }
  }             

  return crossed;
}


//------------------------------------------------------------------------------
//P_uqO_ۥ
bool Line_Cross(LineRec L1, LineRec L2, float *m1, float *m2)
{
	int L1sx, L1sy, L1ex, L1ey,
		L2sx, L2sy, L2ex, L2ey;

	L1sx=L1.SX; L1sy=L1.SY; L1ex=L1.EX; L1ey=L1.EY;
	L2sx=L2.SX; L2sy=L2.SY; L2ex=L2.EX; L2ey=L2.EY;

	return (LineCross(L1sx, L1sy, L1ex, L1ey, L2sx, L2sy, L2ex, L2ey, m1, m2));
}




//--------------------------------------------------------------------------
// P LineCrossInPt() ۦAPOǦ^IAH`ٹBɶ 
bool LineCross(int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, float *m1, float *m2)
{     
  //float m1,m2; //m1: line1 ײvAm2: Line2 ײvC
  short sign1,sign2,sign3,sign4;      //sign#: if point# is beside line or in line
  bool crossed;
  
  crossed=false; *m1=*m2=999999.0;
  
  if (x1!=x2 ) //pGLine1 Ouq
  {
    (*m1)=float(y2-y1)/(x2-x1); //m1: line1 (x1,y1)-(x2,y2) ײv (y2-y1)/(x2-x1)=m1=(y-y1)/(x-x1);
    if (((*m1)*x3-y3)>((*m1)*x1-y1) ) sign3=1;		//f1(x3,y3)>0 sign3=1;
    else if (((*m1)*x3-y3)<((*m1)*x1-y1) ) sign3=-1;	//f1(x3,y3)<0 
    else sign3=0;								//f1(x3,y3)=0

    if (((*m1)*x4-y4)>((*m1)*x1-y1) ) sign4=1;		//f1(x4,y4)>0
    else if (((*m1)*x4-y4)<((*m1)*x1-y1) ) sign4=-1;	//f1(x4,y4)<0
    else sign4=0;								//f1(x4,y4)=0

    if ((sign3==1))		//f1(x3,y3)>0
    {
      if ((sign4==-1))	//f1(x4,y4)*f1(x3,y3)<0
      {
        if (x3!=x4 )	//line2 Duq
        {
          (*m2)=float(y4-y3)/(x4-x3);
          if (((*m2)*x1-y1)>((*m2)*x3-y3) ) sign1=1;		//f2(x1,y1)>0
          else if (((*m2)*x1-y1)<((*m2)*x3-y3) ) sign1=-1;//f2(x1,y1)<0
          else sign1=0;								//f2(x1,y1)=0;

          if (((*m2)*x2-y2)>((*m2)*x3-y3) ) sign2=1;		//f2(x2,y2)>0
          else if (((*m2)*x2-y2)<((*m2)*x3-y3) ) sign2=-1;//f2(x2,y2)<0
          else sign2=0;								//f2(x2,y2)=0

          if (sign1*sign2<=0 ) return true;	//f2(x1,y1)*f2(x2,y2)<=0;	
        }
        else //x3=x4 line2 Ouq
        {
          if ((x1>x3) ) sign1=1;		//x1b line2 k
          else if ((x1<x3) ) sign1=-1;	//x1b line2 
          else sign1=0;					//x1b line2 uW(@wbuqW)
			
          if ((x2>x3) ) sign2=1;
          else if ((x2<x3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) return true;
        }
      }
      else if (sign4==0 )   //sign3=1, sign4=0;  f1(x4,y4)*f1(x3,y3)=0
        if (abs(x4-x1)+abs(x4-x2)==abs(x1-x2) ) return true;
    }
    else if (sign3==-1 )  //sign3=-1;
    {
      if ((sign4==1) )
      {
        if (x3!=x4 )
        {
          (*m2)=float(y4-y3)/(x4-x3);
          if (((*m2)*x1-y1)>((*m2)*x3-y3) ) sign1=1;
          else if (((*m2)*x1-y1)<((*m2)*x3-y3) ) sign1=-1;
          else sign1=0;

          if (((*m2)*x2-y2)>((*m2)*x3-y3) ) sign2=1;
          else if (((*m2)*x2-y2)<((*m2)*x3-y3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) return true;
        }
        else //x3=x4
        {
          if ((x1>x3) ) sign1=1;
          else if ((x1<x3) ) sign1=-1;
          else sign1=0;

          if ((x2>x3) ) sign2=1;
          else if ((x2<x3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) return true;
        }
      }
      else if (sign4==0 )   //sign3=1, sign4=0;
        if (abs(x4-x1)+abs(x4-x2)==abs(x1-x2) ) return true;
    }
    else //sing3=0
    {
      if (abs(x3-x1)+abs(x3-x2)==abs(x1-x2) ) return true;
    }
  }
  else //x1=x2
  {
    if ((x3>x1) ) sign3=1;
    else if ((x3<x1) ) sign3=-1;
    else sign3=0;

    if ((x4>x1) ) sign4=1;
    else if ((x4<x1) ) sign4=-1;
    else sign4=0;

    if ((sign3==1) )
    {
      if ((sign4==-1) )
      {
        if (x3!=x4 )
        {
          (*m2)=float(y4-y3)/(x4-x3);
          if (((*m2)*x1-y1)>((*m2)*x3-y3) ) sign1=1;
          else if (((*m2)*x1-y1)<((*m2)*x3-y3) ) sign1=-1;
          else sign1=0;

          if (((*m2)*x2-y2)>((*m2)*x3-y3) ) sign2=1;
          else if (((*m2)*x2-y2)<((*m2)*x3-y3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) return true;
        }
        else //x3=x4
        {
          if ((x1>x3) ) sign1=1;
          else if ((x1<x3) ) sign1=-1;
          else sign1=0;

          if ((x2>x3) ) sign2=1;
          else if ((x2<x3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) return true;
        }
      }
      else if (sign4==0 )   //sign3=1, sign4=0;
        if (abs(y4-y1)+abs(y4-y2)==abs(y1-y2) ) return true;
    }
    else if (sign3==-1 )  //sign3=-1;
    {
      if ((sign4==1) )
      {
        if (x3!=x4 )
        {
          (*m2)=float(y4-y3)/(x4-x3);
          if (((*m2)*x1-y1)>((*m2)*x3-y3) ) sign1=1;
          else if (((*m2)*x1-y1)<((*m2)*x3-y3) ) sign1=-1;
          else sign1=0;

          if (((*m2)*x2-y2)>((*m2)*x3-y3) ) sign2=1;
          else if (((*m2)*x2-y2)<((*m2)*x3-y3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) return true;
        }
        else //x3=x4
        {
          if ((x1>x3) ) sign1=1;
          else if ((x1<x3) ) sign1=-1;
          else sign1=0;

          if ((x2>x3) ) sign2=1;
          else if ((x2<x3) ) sign2=-1;
          else sign2=0;

          if (sign1*sign2<=0 ) return true;
        }
      }
      else if (sign4==0 )   //sign3=1, sign4=0;
        if (abs(y4-y1)+abs(y4-y2)==abs(y1-y2) ) return true;
    }
    else //sing3=0
    {
      if (abs(y3-y1)+abs(y3-y2)==abs(y1-y2) ) return true;
    }
  }             

  return crossed;
}