//Font.cpp 
//Daniel CopyRight Reserved December, 5, 2001

//\G
//1)  Nreb DirectDrawSurface W

//system includes


//custom includes
#include "Font.h"

//---------------------------------------------------------------------------------
CDdFont::CDdFont(int fH)
{
  Font=0;
  strcpy(FontType,"Fixedsys"); //Arial Black, Fixedsys, Courier New, System, Roman, 
  FontH=(fH>10)?fH:10;
  Create();
}

//---------------------------------------------------------------------------------
CDdFont::~CDdFont()
{
  DeleteObject(Font);
}

//---------------------------------------------------------------------------------
void CDdFont::Create()
{  
  DeleteObject(Font);
  Font=CreateFont(FontH,0,0,0,100,0,0,0,0,0,0,0,0,FontType);  
}

//---------------------------------------------------------------------------------
void CDdFont::SetFontHeight(int H)
{
  FontH=H;
  Create();
}

//---------------------------------------------------------------------------------
void CDdFont::SetFontType(char *tpFnt)
{
  strcpy(FontType,tpFnt);
  Create();
}

//--------------------------------------------------------------------------------
void CDdFont::Draw_Text(char *text, int x,int y, COLORREF Color, LPDIRECTDRAWSURFACE lpdds)
{
	//this function draws text in 16-bit DX mode
	// with the selected font

	HDC dc; // the dc

	// get the dc from surface
	lpdds->GetDC(&dc);

	// set the colors 
	SetTextColor(dc,Color);

	// set background mode to transparent
	// so black isn't copied
	SetBkMode(dc, TRANSPARENT);

	// draw the text using the font
	SelectObject(dc, Font);
	TextOut(dc,x,y,text,strlen(text));
	
	// release the dc
	lpdds->ReleaseDC(dc);
} 




/* TextOut Tips********************************************************************

//1) pr Pixel --------------------------------------------------------------
	
	GetClientRect(hWnd, &rc);
	GetTextExtentPoint(hdc, szMsg, lstrlen(szMsg), &size);
	TextOut(hdc, (rc.right - size.cx) / 2, (rc.bottom - size.cy) / 2, 
			szMsg, sizeof(szMsg) - 1);
	TextOut(hdc, 0, 0, szFrontMsg, lstrlen(szFrontMsg));


*/