//Object.h    header file of Object.cpp
//Daniel CopyRight Reserved December, 17, 2001

//system includes
#include <windows.h>
#include <windef.h>
#include <ddraw.h>

//custom includes
#include "Sprite.h"

#ifndef _object_h_
#define _object_h_

#include "WorldSystem.h"

//wqߡBBkBWBUBkWBW....ƭ
//enum MoveDir{Orgn=0, Dir0, Dir45, Dir90, Dir135, Dir180, Dir225, Dir270, Dir315}; //KӲʤV


class CStillObject  //|ʪ
{
	protected:
		CSprite *Sprite; //ҦpA𸭷nʪʵeC
		int FrameNum;
		int FrameW, FrameH;
		int LastFrameTime;
		int curFrameNo;
		int FramePeriod;
		int curX, curY; //Spriteߦmb World y

	public:
		CStillObject();
		BOOL Create(CSprite *sprite, int x, int y, int frameno, int frameperiod); //]wm		
		virtual void Draw(LPDIRECTDRAWSURFACE lpSurface);
		int PosX(); //return curX
		int PosY();
};


class CWiseObject : public CStillObject //|ʪ,iIApǪC
{
	private:		
		CSprite *Sprite[corner315+1];  //VWUkA 45, 135, 225, 315 KӨתSprite					

	protected:
		unsigned char curMovement; //O{bʤV
		int MinSpeed, MaxSpeed, CurSpeed;		
		int XSpeed,YSpeed; //b Move() 
		int LastMoveTime;

	public:
		ObjDir curDir;
		CWiseObject();	
		BOOL Create(CSprite *sprite[corner315+1], int x, int y, int frameno, int frameperiod,
					int Vx, int Vy); //]wm		
		virtual void Draw(LPDIRECTDRAWSURFACE lpSurface);
		virtual void Move();	
		void RefreshDirection(int x, int y);
		void Accelerate(int dv);
};


class CPlayerObject : public CWiseObject
{
	public:
		CPlayerObject(); //~ CWiseObject  Constructor ҦeAA[Ws lưʧ@C
		bool AutoMove;
		virtual void Move();
		void IncMove(int dx, int dy);
		void SetPos(int x, int y);		
};

#endif 
