//Particle.cpp: member functions for the Particle.h
//Daniel CopyRight Reserved December, 26, 2001



//system includes

//custom includes
#include "palette.h"
#include "Random.h"



extern CRandom Random;



//إߤltΦL -------------------------------------------------------------------
void CreateFirePalette(PALETTEENTRY *FirePalette)
{
	unsigned char index = 0;

	
	for (index = 1; index < 35; index++)
	{
	    FirePalette[index].peRed   = index+35;
	    FirePalette[index].peGreen = Random.number(15,25);
	    FirePalette[index].peBlue  = Random.number(5,10);
	}
	for (index = 35; index < 55; index++)
	{
	    FirePalette[index].peRed   = index+Random.number(30,55);;
	    FirePalette[index].peGreen = index+Random.number(10,20);
	    FirePalette[index].peBlue  = Random.number(30,7);
	}
	for (index = 55; index < 95; index++)
	{
	    FirePalette[index].peRed = index+15;
	    FirePalette[index].peGreen = index-15;
	    FirePalette[index].peBlue = Random.number(10,20);
	}
	for (index=95;index<200;index++)
	{
		FirePalette[index].peRed   = index+25;
		FirePalette[index].peGreen = index-30;
		FirePalette[index].peBlue  = Random.number(10,20);
	}
	for(index = 200; index < 255; index++)
	{
		FirePalette[index].peRed = index;
		FirePalette[index].peGreen = index-10;
		FirePalette[index].peBlue = Random.number(50,80);
	}

	FirePalette[255].peRed = 200;
	FirePalette[255].peGreen = 255;
	FirePalette[255].peBlue = 200;	
}



void CreateBluePalette(PALETTEENTRY *BluePalette)
{
	unsigned char index = 0;

	
	for (index = 1; index < 35; index++)
	{
	    BluePalette[index].peRed   = index+5;
	    BluePalette[index].peGreen = index+10;
	    BluePalette[index].peBlue  = index+Random.number(5,10);
	}
	for (index = 35; index < 55; index++)
	{
	    BluePalette[index].peRed   = index-10;
	    BluePalette[index].peGreen = index+Random.number(10,50);
	    BluePalette[index].peBlue  = index+10;
	}
	for (index = 55; index < 95; index++)
	{
	    BluePalette[index].peRed = index-20;
	    BluePalette[index].peGreen = index-15;
	    BluePalette[index].peBlue = index+50;
	}
	for (index=95;index<200;index++)
	{
		BluePalette[index].peRed   = index-Random.number(50,70);
		BluePalette[index].peGreen = index-30;
		BluePalette[index].peBlue  = index+40;
	}
	for(index = 200; index < 255; index++)
	{
		BluePalette[index].peRed = Random.number(150,200);
		BluePalette[index].peGreen = index-Random.number(1,20);
		BluePalette[index].peBlue = index;
	}

	BluePalette[255].peRed = 250;
	BluePalette[255].peGreen = 250;
	BluePalette[255].peBlue = 255;	
}