//world.h 
//Daniel CopyRight Reserved December, 5, 2001

//\G
//1) ;ӵC@ɡA쬰IɪeAjp䭿
//2) OثeIyСAHĤ@H@ɮyШt
//3) ǤJO_P@ɸI 
//4) World <---> Screen yഫ
//5) eXIid򤺪I
//6) pYyЦ World ĴXC  RowOfPosition();


/*	World Coordinate System

 (Row)					 |<>| <-ImgBkgW    +Y
	-------------------------				^
  4	|  |  |  |  |  |  |  |  |				|
	-------------------------  --			|
  3	|  |  |  |  |  |  |  |  |	ImgBkgH		|
	-------------------------  --			|
  2	|  |  |  |  |  |  |  |  |				|
	------------------------				|
  1	|  |  |  |  |  |  |  |  |				|
	-------------------------				|
  0	|  |  |  |  |  |  |  |  |				|
	-------------------------				|
	 0  1  2  3  4  5  6  7   (Col)			|
											|________________________>  +X
    0  1  2  3  4  5  6  7  8 (ColLine)		(0,0)  
*/

//System includes
#include <ddraw.h>
#include <windef.h>

//Custom includes
#include "Glvar.h"
#include "TypeDef.h"
#include "bmp.h"

#ifndef __world_h__
#define __world_h__


//custom defines--------------------------------------------------------------------

//wqߡBBkBWBUBkWBW....ƭ
//enum worldside{center=0, left, right, top, bottom, corner45, corner135, corner225, corner315};

class CWorld2D  //WorldO
{ 
  private:
	CBmpSpriteFileReader *ImgBkgPtr;
    RowRec *WorldRow;	//ӥ@ɡAC@C_IC
	LPDIRECTDRAWSURFACE lpBkgSurface[corner315+1];	
	LPDIRECTDRAWSURFACE lpMapSurface;
	unsigned short ColNum;	//WorldeװHIϼeתơAYơC
	unsigned short RowNum;	//WorldeװHIϼeתơAYCơC
	POINT *MapPt; //ɰwqĤ@C̥UIҦI X, Y
	double MapResolution; //  world 1 pixel  YpaϤW h pixels
	unsigned short MapSidePixel;

  protected:	
	void AutoCaculateSize();
	BOOL CreateSurfaces();

  public: 
	int ViewX, ViewY;   //Iy	   
 	COLORREF MapColor;
	bool ShowMap;

    CWorld2D(); //constructor
    ~CWorld2D(); //destructor	
	
	void ReleaseSurfaces();
	BOOL RestoreSurfaces();

	BOOL RandomCreate(CBmpSpriteFileReader *ImgBkgndPtr, int worldW, int worldH);
	void SetViewPoint(int x, int y); //]wIy, ö}le
	void MoveViewPoint(int *x, int *y); //NIqثe (ViewX, ViewY) ʨs (x,y)C
	void IncMoveViewPoint(int dx, int dy); //Wq
	bool InsideWorld(int x, int y, short *posRow, short *posCol);	 //P_O_b World 
		//P_O_töǦ^IΤϮg
	bool HitWorldEdge(int x1, int y1, int *x2, int *y2,int *xc, int *yc);
	bool drawBackGround2Surface(LPDIRECTDRAWSURFACE lpSurface); //ھڵImeXI
	short RowOfXY(int y);  //Ǧ^ XY b World ҦbC Row No.
	short ColOfXY(int x);  //Ǧ^ XY b World Ҧb Col No.
	
	int WorldToScreenX(int x);// World X yùy
	int WorldToScreenY(int y);// World Y yùy
	int ScreenToWorldX(int x);
	int ScreenToWorldY(int y);
	short WorldRowNum();
	short WorldColNum();
	RowRec StartEndColInRow(int row);
	void GetRandomPosInWorld(int *x, int *y);
		
	bool DrawMap2Surface(LPDIRECTDRAWSURFACE lpSurface, int x, int y, bool Solid); //eYpa
	bool DrawWorldMap2MapSurface();
	bool BlendDrawMap2Surface(LPDIRECTDRAWSURFACE lpSurface,int x, int y);
	int WorldToMapX(int x);// World X ylpWorldMapSurfaceùy
	int WorldToMapY(int y);// World Y ylpWorldMapSurfaceùy
};

#endif