//ddrawUtil.h    header file of Font.cpp
//Daniel CopyRight Reserved December, 12, 2001


//system includes
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>

//custom includes
#include "glvar.h"

#ifndef _ddrawutil_h_
#define _ddrawutil_h_


//b DirectDrawSurface We Rectangle
bool DrawSurfaceRect(LPDIRECTDRAWSURFACE lpSurface, RECT rect, COLORREF color);

//b DirectDrawSurface We Polygon
bool DrawSurfacePolygon(LPDIRECTDRAWSURFACE lpSurface, POINT *pt, int ptNum, COLORREF color);
bool DrawSurfacePolyline(LPDIRECTDRAWSURFACE lpSurface, POINT *pt, int ptNum, COLORREF color);

//b DirectDrawSurface We Ellipse
bool DrawSurfaceEllipse(LPDIRECTDRAWSURFACE lpSurface, int cx, int cy, int r, COLORREF color);

//b DirectDrawSurface We Rectangle
bool BlendSurface(LPDIRECTDRAWSURFACE lpSurfaceDest, int destx,int desty,int destw,int desth, 
				  LPDIRECTDRAWSURFACE lpSurfaceSrc, int srcx, int srcy, int srcw, int srch,
				  unsigned char srcAlpha);
bool CBlendSurface(LPDIRECTDRAWSURFACE lpSurfaceDest, int destx,int desty, 
				  LPDIRECTDRAWSURFACE lpSurfaceSrc, int srcw, int srch);

//N Surface񺡬YC
bool ColorFillSurface(LPDIRECTDRAWSURFACE lpSurface, unsigned short palleteID);


#endif