//Particle.cpp: member functions for the Particle.h
//Daniel CopyRight Reserved December, 26, 2001



//system includes
#include <windows.h>
#include <math.h>

//custom includes
#include "particle.h"
#include "Random.h"
#include "Glvar.h"

//~ܼ----------------------------------------------------
extern CRandom Random;
extern float SIN(short deg);
extern float COS(short deg);

CParticle::CParticle()
{
}

CParticle::~CParticle()
{
}


void CParticle::Create(int x, int y)
{
	short minVec=5, maxVec=10;

	curX=x; curY=y;
	Speed=Random.number(minVec, maxVec);
	Angle=Random.number(0,255);
	dAngle=Random.number(1,10);//Random.Sign()*Random.number(1,50)/1000.0f;
	Life=1.0f;
	Decay=Random.number(1,20)/50.0f;
}


void CParticle::Move()
{
	if(Life<=0) return;

	curX+=int(Speed*COS(Angle));
	curY+=int(Speed*SIN(Angle));
	
	//Angle=Random.number(0,255);
	Angle+=dAngle;

	Life-=Decay;
}
