//sprite.h: header file for the sprite.cpp
//Daniel CopyRight Reserved December, 13, 2001

//\G
//1) Hold sprite Ҧiƪ Surface ơC
//2) O`iơBסBe



//System includes
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>

//Custom includes
#include "Glvar.h"
#include "bmp.h"


#ifndef _sprite_h_
#define _sprite_h_

class CSprite
{
  protected:
	CBmpSpriteFileReader *ImgSpritePtr;
	int ImgStartX, ImgStartY; //b Bmp ϧθƪ_I
	LPDIRECTDRAWSURFACE *lpSpriteSurfaces; //lpFrameSurface[FrameNum]
	int FrameNum;
	int FrameW, FrameH; //]CiۦPe
	RECT FrameRect;
	BOOL CreateSurfaces(); //tm Video Ram (Surface) ŶC

  public:
	CSprite();
	~CSprite();

	BOOL CreateSprite(CBmpSpriteFileReader *imgptr, int ImgX, int ImgY,
					  int frames, int framew, int frameh);	
	void Draw2Surface(LPDIRECTDRAWSURFACE lpDestSurface, int x, int y, int FrameNo);
	void AlphaDraw2Surface(LPDIRECTDRAWSURFACE lpDestSurface, int x, int y, int FrameNo);
	virtual BOOL RestoreSurfaces();
	void ReleaseSurfaces();
	LPDIRECTDRAWSURFACE Frame(int i); //for debug use,Ǧ^ i i Frame Surface СC
	int FrameWidth();
	int FrameHeight();
	int TotalFrames();
};




//************************************************************************
class CAlphaSprite : public CSprite
{
  protected:
	BYTE Alpha;

  public:	
	CAlphaSprite(BYTE alpha);
	virtual BOOL RestoreSurfaces();
	void SetAlpha(BYTE alpha);			
};


#endif
